import java.io.*;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.Scanner;

public class Las {
    List<Drzewo> drzewa;

    public Las() {
        drzewa = new ArrayList<>();

        drzewa.add(new DrzewoLisciaste("brzoza", 16, 23));
        drzewa.add(new DrzewoIglaste("modrzew", 10));

        System.out.println("test");
        wczytaj("drzewa.txt");
        wyswietlWszystkie();
        System.out.println();
        zrzucWszystkieLiscie();
        System.out.println();

        Drzewo tmp = drzewa.get(1);
        tmp.setWiek(166);

        System.out.println("gatunek " + tmp.getGatunek());
        System.out.println("wiek " + tmp.getWiek());
        // jezeli klasa obiektu to DrzewoLisciaste, wyswietl dodatkowo wysokosc
        if(tmp.getClass().getSimpleName() == "DrzewoLisciaste") {
            DrzewoLisciaste a = (DrzewoLisciaste) tmp;
            System.out.println("wysokosc " + a.getWysokosc());
            a.setWysokosc(666);
            System.out.println("wysokosc " + a.getWysokosc());
        }

        Drzewo tmp2 = drzewa.get(0);
        tmp2.setWiek(170);

        System.out.println("gatunek " + tmp2.getGatunek());
        System.out.println("wiek " + tmp2.getWiek());
        // jezeli klasa obiektu to DrzewoLisciaste, wyswietl dodatkowo wysokosc
        if(tmp2.getClass().getSimpleName() == "DrzewoLisciaste") {
            DrzewoLisciaste a = (DrzewoLisciaste) tmp2;
            System.out.println("wysokosc " + a.getWysokosc());
            a.setWysokosc(666);
            System.out.println("wysokosc " + a.getWysokosc());
        }

        System.out.println();
        wyswietlWszystkie();
        System.out.println();

        try {
            wyswietlPosortowaneIZapisz();
        } catch(IOException e) {
            System.out.println("Nie mozna zapisac pliku: ");
            e.printStackTrace();
        }
    }

    public void wyswietlWszystkie() {
        for (Drzewo drzewo : drzewa) {
            System.out.println(drzewo.toString());
        }
    }

    public void zrzucWszystkieLiscie() {
        for (Drzewo drzewo : drzewa) {
            try {
                drzewo.zrzucLiscie();
            } catch(NieMoznaZrzucicException e) {
                System.out.println("nie mozna zrzucic lisci");
            }
        }
    }

    public void wczytaj(String path) {
        try {
            File plik = new File(path);
            Scanner scanner = new Scanner(plik);

            while(scanner.hasNextLine()) {
                String line = scanner.nextLine();
                String[] elements = line.split(";");
                // 0 typ; 1 gatunek; 2 wiek; 3 wysokosc
                Drzewo temp;
                switch(elements[0]) {
                    case "iglaste":
                        temp = new DrzewoIglaste(elements[1], Integer.parseInt(elements[2]));
                        break;
                    case "lisciaste":
                        temp = new DrzewoLisciaste(elements[1], Integer.parseInt(elements[2]), Integer.parseInt(elements[3]));
                        break;
                    default: // domyslnie zakladamy ze to iglak (mniej pol danych)
                             // poniewaz Drzewo jest abstrakcyjne,
                             // nie mozna utworzyc obiektu klasy Drzewo
                        temp = new DrzewoIglaste("nieznany", 0);
                        break;
                }
                drzewa.add(temp);
            }
            scanner.close();
        } catch (FileNotFoundException e) {
            System.out.println("Nie znaleziono pliku");
        }
    }

    public void wyswietlPosortowaneIZapisz() throws IOException {
        List<Drzewo> sorted = new ArrayList<Drzewo>(drzewa);
        sorted.sort(new DrzewaComparator());

        String str = "";
        for (Drzewo drzewo : sorted) {
            System.out.println(drzewo.toString());
            str += drzewo.toString();
            str += "\n";
        }

        System.out.print("Podaj nazwe pliku do zapisu: ");
        Scanner scanner = new Scanner(System.in);
        String nazwaPliku = scanner.next();

        BufferedWriter w = new BufferedWriter(new FileWriter(nazwaPliku));
        w.write(str);
        w.close();
    }
}

class DrzewaComparator implements Comparator<Drzewo> {
    @Override
    public int compare(Drzewo d1, Drzewo d2) {
        if(d1.getWiek() == d2.getWiek()) return 0;
        if(d1.getWiek() > d2.getWiek()) return 1;
        return -1;
    }
}
